
#include "comb/perm-st-pref.h"
//demo-include "comb/endo-enup.h"


#include "comb/comb-print.h"
#include "aux0/swap.h"

#include "fxtio.h"
#include "nextarg.h"
#include "fxttypes.h"


//% OEIS sequence A368948:
//% First track of single track permutations with swaps in prefix.

// Cf. comb/perm-st-pref-demo.cc



int
main(int argc, char **argv)
{
    ulong n = 5;
    NXARG(n, "Number of elements to permute");

    perm_st_pref P(n);

    ulong ct = 0;
    P.first();
    do
    {
        cout << P.data()[0] << ", ";
//        cout << ct << " " << P.data()[0] << endl;  // b-file
        ++ct;
    }
    while ( P.next() );


    cout << endl;
    cout << " ct = " << ct << endl;

    return 0;
}
// -------------------------

/*
Sequence(s):  (not in OEIS)  A368948

% echo $(./bin 5 | cut -b 12 | sed 's/\./0/g;') | sed 's/ /,/g;'
0,1,2,2,1,0,1,0,0,1,2,2,3,3,3,3,3,3,2,2,1,0,0,1,2,2,1,0,0,1,0,1,2,2,1,0,...

% echo $(./bin 5 | cut -b 12 | sed 's/\./0/g;') | sed 's/ /,/g;' | tr '0123456' '1234567'
1,2,3,3,2,1,2,1,1,2,3,3,4,4,4,4,4,4,3,3,2,1,1,2,3,3,2,1,1,2,1,2,3,3,2,1,...

*/


/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/seq"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/seq/A368948-demo.cc"
/// make-target2: "1demo DSRC=demo/seq/A368948-demo.cc DEMOFLAGS=-DTIMING"
/// End:

